package step

// Error enumerates errors common to this package.
type Error string; const (
	ErrCircularInheritance  Error = "circular inheritance"
	ErrExecutionCanceled    Error = "execution canceled"
	ErrMetaMalformed        Error = "metadata is malformed"
	ErrMetaNeverClosed      Error = "metadata is never closed"
	ErrTypeMismatch         Error = "type mismatch"
	ErrPluginBadSymbol      Error = "plugin has an incorrect symbol"
	ErrPluginNotOwnedByRoot Error = "plugin is not owned by the root user"
	ErrPathNotAbsolute      Error = "path is not absolute"
	ErrInsufficientSystem   Error = "the system cannot perform this action"
)

// Error fulfills the error interface.
func (err Error) Error () string {
	return string(err)
}

// Errors is any error that unwraps to a list of sub-errors.
type Errors interface {
	Unwrap () []error
}
